<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\TkEvaluator;
use HCM\Util\FPA;

class TeknisaEvaluator extends TkEvaluator{

    private $_teknisaRegra;

    public function __construct($teknisa_regra){
        parent::__construct();
        $this->_teknisaRegra = $teknisa_regra;
        $this->_declaraVariaveis();
        $this->_declaraRegras();
    }

    private function _declaraVariaveis(){
        $this->setVar('CDOPERADOR', "'".FPA::getCdOperador()."'");
    }

    private function _declaraRegras(){
        $this->setObjectFunction('VALOR_MAX', $this->_teknisaRegra, 'retornaMaiorValor', array('valor_1', 'valor_2'));
        $this->setObjectFunction('VALOR_MIN', $this->_teknisaRegra, 'retornaMenorValor', array('valor_1', 'valor_2'));
        $this->setObjectFunction(
            'COMPARA_VALOR', $this->_teknisaRegra, 'comparaValores',
            array(
                'valor_1', 'comparacao', 'valor_2',
            )
        );

        $this->setObjectFunction(
            'VALOR_ALEATORIO', $this->_teknisaRegra, 'retornaValorAleatorio',
            array(
                'limiteMin', 'limiteMax',
            )
        );
        $this->setObjectFunction('DATA_PARTE', $this->_teknisaRegra, 'retornaDataPorParte', array('data', 'tipo'));
        $this->setObjectFunction('DATA_DIFERENCA', $this->_teknisaRegra, 'retornaDiferencaDatas', array('data_1', 'data_2', 'tipo'));
    }
}